Subject: Re: [multipathtcp] MPTCP Simulation

From: Vikas Raunak <[email-masked]>
Date: Sun, 1 Nov 2015 01:40:46 +0530

Dear sir

Thanks a lot for your reply.

The observations were for : 50 Mbps, 1ms (subflow 0) and 5 Mbps, 100 ms
(subflow 1) p2p links (ns-3) under Round Robin scheduling and LIA
congestion control algorithm.

Sir, my doubt pertains to the way retransmission (driven by dup acks) is
done in MPTCP. If Retransmissions are driven only by subflow sequence
numbers: this should not cause reductions in cwnd of faster link under any
scheduling (even under RR, which is not the default scheduling algorithm
for the Linux MPTCP kernel).

In my understanding, an ACK in MPTCP has a DSS option that contains a Data
Ack (for flow control only), and the normal subflow-level ack (as in TCP)
drives retransmissions. So, if a subflow gets 3 acks with same data ack
field but different subflow-level field, then it should not retransmit,
since it is not a dup-ack at the subflow level.

The explanation of the behaviour in the figure: the behaviour could only
happen (repeated retransmissions on the faster subflow) when data-acks also
participate in retransmissions i.e. two acks with same data field are
considered as duplicates. As packets on faster link arrive earlier (more
"dup data acks"), repeated halving of the faster link's cwnd suppresses it.

Sir, I would be very grateful if you could spare some time considering this
problem/doubt. Sir, please correct me if I am making a misinterpretation (I
suspect this is a very big issue, which if true makes the ns-3 model wrong).

Thanks a lot.
Regards
Vikas

On Sat, Oct 31, 2015 at 10:59 PM, Martin Becke <[email-masked]> wrote:

> Hi,
>
> i created a simulation in omen++/inet  for several months.
> I had the same observation in some scenarios with short FIFO Queues.
> Here the behavior was caused by a short FIFO queue and a huge difference
> in the BDP (for example on connecting routers).
> Have you more information about your queue status and the BDP of both
> paths?
> I was not able to reproduce this effect in a real testbed.
>
> Best,
>
> Martin
>
>
> Am 29.10.2015 um 12:53 schrieb Vikas Raunak <[email-masked]>:
>
> Hi
>
> I am working on MPTCP using the ns-3 simulator
> <https://hal.archives-ouvertes.fr/hal-00641539/document>. I have a very
> important observation.
>
> Please consider the attached figure. In this, the congestion window of
> faster delay subflow (subflow 0) is reduced under Round Robin scheduling.
>
> The simulator repeatedly halves the congestion window of the faster
> subflow. Why is it happening ? As per MPTCP specifications this should not
> happen.
>
> Could you explain this observation. I have tried to seek the explanation
> from a lot of people and yet, I have no answer.
>
> Thanks a lot for your help.
> Regards
> Vikas
> _______________________________________________
> multipathtcp mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/multipathtcp
>
>
>